using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

/// <summary>
/// 圣火点燃开始游戏的流程管理
/// </summary>
public class FireController : MonoBehaviour
{
    private void OnTriggerEnter2D(Collider2D other) {
        if(other.TryGetComponent<Person>(out var person)) {
            //当人进入点燃圣火触发器
            StartCoroutine(LightFireCoroutine());
        }
    }

    private IEnumerator LightFireCoroutine(){
        yield return new WaitForEndOfFrame();
        //由于圣火动画还没有，暂时空着
        //
        //此时圣火已点燃，标题已显示
        
        //呼出黑块从右向左的动画
        BlackController.Instance.Trans();
        //直到黑幕全黑
        yield return new WaitUntil(() => {return BlackController.Instance.AllBlack;});
        //开始跳转到下一个场景
        SceneManager.LoadScene("0813中期提交");
    }
}
